#include<bits\stdc++.h>

using namespace std;

int gcd(int a, int b)
{
   if (b == 0)
   return a;
   return gcd(b, a % b);
}

int main()
{
	int t, r[5];
	cin>>t;
	for(int i = 0; i < t; i++)
	{
		r[i] = 0;
		int n, m;
		cin>>n>>m;
		long long a[75000], b[75000], x;
		for(int j = 0; j < n; j++) cin>>a[j];
		for(int j = 0; j < m; j++) cin>>b[j];
		if(n == 1) break;
		sort(a, a + n);
		x = a[1] - a[0];
		for(int j = 2; j < n; j++) x = gcd(x, a[j] - a[j - 1]);
		for(int j = 0; j < m; j++) if(((b[j] - a[0]) % x) != 0) r[i] = 1;
	}
	for(int i = 0; i < t; i++) cout<<r[i]<<endl;
}